# bigip_profile_http2 – Manage HTTP2 profiles on a BIG-IP

New in version 2.8.

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manage HTTP2 profiles on a BIG-IP.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

activation_modes
list

Choices:
- alpn
- always

Specifies what will cause an incoming connection to be handled as a HTTP/2 connection.
The `alpn` and `always` are mutually exclusive.
When creating a new profile, if this parameter is not specified, the default is provided by the parent profile.

description string |  | Description of the profile.

enforce_tls_requirements
boolean

Choices:
- no
- yes

Specifies whether the system requires TLS for communications between specified senders and recipients.
When creating a new profile, if this parameter is not specified, the default is provided by the parent profile.

frame_size integer |  | Specifies the size of data frames, in bytes, that HTTP/2 sends to the client. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile. The valid value range in bytes is `1024 - 16384`.
header_table_size integer |  | Specifies the size of the header table, in bytes. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile. The valid value range in bytes is `0 - 65535`.
idle_timeout integer |  | Specifies the number of seconds that an HTTP/2 connection is idly left open before being shut down. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile.

insert_header
boolean

Choices:
- no
- yes

Specifies whether an HTTP header indicating the use of HTTP/2 should be inserted into the request that goes to the server.
When creating a new profile, if this parameter is not specified, the default is provided by the parent profile.

insert_header_name string |  | Specifies the name of the HTTP header controlled by `insert_header` parameter. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile.
name string / required |  | Specifies the name of the profile.
parent string | Default: "/Common/http2" | Specifies the profile from which this profile inherits settings. When creating a new profile, if this parameter is not specified, the default is the system-supplied `http2` profile.
partition string | Default: "Common" | Device partition to manage resources on.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.

transport
string

Choices:
- cli
- rest ←

Configures the transport connection to use when connecting to the remote device.

| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates.
You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.

receive_window integer |  | Specifies the way that the HTTP/2 profile performs flow control. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile. The valid value range in kilobytes is `16 - 128`.

state
string

Choices:
- present ←
- absent

When `present`, ensures that the profile exists.
When `absent`, ensures the profile is removed.

streams integer |  | Specifies the number of outstanding concurrent requests that are allowed on a single HTTP/2 connection. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile. The valid value range is `1 - 256`.
write_size integer |  | Specifies the total size of combined data frames, in bytes, that HTTP/2 sends in a single write. When creating a new profile, if this parameter is not specified, the default is provided by the parent profile. The valid value range in bytes is `2048 - 32768`.

## Notes

Note

- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.
- Requires BIG-IP software version >= 12.
- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Create HTTP2 profile
      bigip_profile_http2:
        name: my_profile
        insert_header: yes
        insert_header_name: FOO
        state: present
        provider:
          user: admin
          password: secret
          server: lb.mydomain.com
      delegate_to: localhost

    - name: Remove HTTP profile
      bigip_profile_http2:
        name: my_profile
        state: absent
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

    - name: Add HTTP profile set activation modes
      bigip_profile_http:
        name: my_profile
        activation_modes:
          - always
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
activation_modes list | changed | Specifies HTTP/2 connection handling modes Sample: ['always']
description string | changed | Description of the profile. Sample: My profile
enforce_tls_requirements boolean | changed | pecifies whether the system requires TLS for communications. Sample: True
frame_size integer | changed | The size of the data frames Sample: 30
insert_header_name string | changed | Specifies the name of the HTTP2 header Sample: X-HTTP2
streams integer | changed | The number of outstanding concurrent requests allowed on a single HTTP/2 connection Sample: 30

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by an Ansible Partner. [certified]

### Authors

- Wojciech Wypior (@wojtek0806)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.